[indent=4]


/*----------------------------------------------------

  this is the MAIN program.
  here you initialize all libraries,
  build your window,
  and define the actions for the window.



------------------------------------------------------*/


uses
    Gtk


//-- Global variables --

window1 : Window
picview : Pictureviewclass

//-- custom methods --
def set_title()

    var name = picview.filename.get_text()
    window1.set_title(Filename.display_basename(name))
    return


def drop(d : Gdk.DragContext , x : int, y : int , sel : Gtk.SelectionData, info : uint , timestamp : uint) 


    //-- manage drag n drop --
    
    var uriustring =  (string) sel.data
    var uri = uriustring.split("\n")[0].strip()

    picview.load_picture(uri)
    return

//-- main program --

init

    Gtk.init (ref args) 

    //-- build the first window -- 

    window1 = new Gtk.Window (Gtk.WindowType.TOPLEVEL) 
    window1.set_default_size (780, 540) 
    window1.destroy += Gtk.main_quit 
    window1.set_title("Picture viewer") 
    window1.move(0 , 40) 
  
    var vbox = new Gtk.VBox(false , 1) 
    vbox.border_width = 10 
    vbox.spacing = 10 
    window1.add (vbox) 
    

    //-- use the class --    
 
    picview = new Pictureviewclass ()
    picview.init()
    vbox.add(picview.vbox)    
    
    
    picview.add_run_button("gqview" , "gqview")
    picview.add_run_button("mtpaint" , "mtpaint")
    picview.add_run_button("gimp" , "gimp")
    picview.add_run_button("wallpaper" , "set_wallpaper")
 
    var thefile = Environment.get_current_dir() + "/graphics.png"
    
    if args.length > 1
        thefile = args[1]
 

    window1.show_all() 

    //-- react on a change --
    picview.filename.changed += set_title
    
    //-- must load a picture AFTER window is visible ! --

    picview.load_picture(thefile)

    //-- must set resize event AFTER picview was assigned to a window ! --    
    window1.check_resize += picview.on_size_request  

    //-- add a custom drag and drop action --
    picview.eventbox.drag_data_received += drop

    Gtk.main ()



